#ifndef _DATA_H
#define _DATA_H

#include "stm32f10x.h"

#include "usart.h"
#include "spi.h"
#include "24l01.h"
#include "led.h"
#include "wkup.h"

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <math.h>

#define MAX_MESSAGE_LEN 32		//Ϣ
#define MAX_PAYLOAD_BUF_LEN (MAX_MESSAGE_LEN -sizeof(NRF24PayloadHeader))//Ϣ
#define MAC_LEN			5		//

#pragma pack(1)
typedef struct 
{
	u8	src_addr;	//Դַ
	u8	dst_addr;	//Ŀĵַ
	u8	type;		//
	u8	ID;			//payload ID
	u8	node_num;	//бڵ
}NRF24PayloadHeader,*LNRF24PayloadHeader; //payloadͷṹ

typedef struct
{
	NRF24PayloadHeader Header;		//payload ͷ
	char buf[MAX_PAYLOAD_BUF_LEN];//ݻ
}NRF24Payload,*LNRF24Payload;	//payloadṹ 
#pragma pack()

//IOڲ궨
#define BITBAND(addr, bitnum) ((addr & 0xF0000000)+0x2000000+((addr &0xFFFFF)<<5)+(bitnum<<2)) 
#define MEM_ADDR(addr)  *((volatile unsigned long  *)(addr)) 
#define BIT_ADDR(addr, bitnum)   MEM_ADDR(BITBAND(addr, bitnum)) 

//IOڵַӳ
#define GPIOA_ODR_Addr    (GPIOA_BASE+12) //0x4001080C 
#define GPIOB_ODR_Addr    (GPIOB_BASE+12) //0x40010C0C 
#define GPIOC_ODR_Addr    (GPIOC_BASE+12) //0x4001100C 

#define GPIOA_IDR_Addr    (GPIOA_BASE+8) //0x40010808 
#define GPIOB_IDR_Addr    (GPIOB_BASE+8) //0x40010C08 
#define GPIOC_IDR_Addr    (GPIOC_BASE+8) //0x40011008 

//IOڲ,ֻԵһIO!
//ȷnֵС16!
#define PAout(n)   BIT_ADDR(GPIOA_ODR_Addr,n)  // 
#define PAin(n)    BIT_ADDR(GPIOA_IDR_Addr,n)  // 

#define PBout(n)   BIT_ADDR(GPIOB_ODR_Addr,n)  // 
#define PBin(n)    BIT_ADDR(GPIOB_IDR_Addr,n)  // 

#define PCout(n)   BIT_ADDR(GPIOC_ODR_Addr,n)  // 
#define PCin(n)    BIT_ADDR(GPIOC_IDR_Addr,n)  // 

#endif
